bcm53xx: support sysupgrade with Netgear R7000 original firmware
[openwrt.git] / target / linux / bcm53xx / base-files / lib / upgrade / platform.sh
1 PART_NAME=firmware
2
3 # $(1): file to read magic from
4 # $(2): offset in bytes
5 get_magic_long_at() {
6         dd if="$1" skip=$2 bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%02x"'
7 }
8
9 platform_machine() {
10         cat /proc/device-tree/compatible | tr '\0' '\t' | cut -f 1
11 }
12
13 platform_flash_type() {
14         # On NAND devices "rootfs" is UBI volume, so won't be find in /proc/mtd
15         grep -q "\"rootfs\"" /proc/mtd && {
16                 echo "serial"
17                 return
18         }
19
20         echo "nand"
21 }
22
23 platform_expected_image() {
24         local machine=$(platform_machine)
25
26         case "$machine" in
27                 "netgear,r6250v1")      echo "chk U12H245T00_NETGEAR"; return;;
28                 "netgear,r6300v2")      echo "chk U12H240T00_NETGEAR"; return;;
29                 "netgear,r7000")        echo "chk U12H270T00_NETGEAR"; return;;
30                 "netgear,r8000")        echo "chk U12H315T00_NETGEAR"; return;;
31         esac
32 }
33
34 platform_identify() {
35         local magic
36
37         magic=$(get_magic_long "$1")
38         case "$magic" in
39                 "48445230")
40                         echo "trx"
41                         return
42                         ;;
43                 "2a23245e")
44                         echo "chk"
45                         return
46                         ;;
47         esac
48
49         magic=$(get_magic_long_at "$1" 14)
50         [ "$magic" = "55324e44" ] && {
51                 echo "cybertan"
52                 return
53         }
54
55         echo "unknown"
56 }
57
58 platform_check_image() {
59         [ "$#" -gt 1 ] && return 1
60
61         local file_type=$(platform_identify "$1")
62         local magic
63         local error=0
64
65         case "$file_type" in
66                 "chk")
67                         local header_len=$((0x$(get_magic_long_at "$1" 4)))
68                         local board_id_len=$(($header_len - 40))
69                         local board_id=$(dd if="$1" skip=40 bs=1 count=$board_id_len 2>/dev/null | hexdump -v -e '1/1 "%c"')
70                         local dev_board_id=$(platform_expected_image)
71                         echo "Found CHK image with device board_id $board_id"
72
73                         [ -n "$dev_board_id" -a "chk $board_id" != "$dev_board_id" ] && {
74                                 echo "Firmware board_id doesn't match device board_id ($dev_board_id)"
75                                 error=1
76                         }
77
78                         if ! otrx check "$1" -o "$header_len"; then
79                                 echo "No valid TRX firmware in the CHK image"
80                                 error=1
81                         fi
82                 ;;
83                 "cybertan")
84                         local pattern=$(dd if="$1" bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%c"')
85                         local dev_pattern=$(platform_expected_image)
86                         echo "Found CyberTAN image with device pattern: $pattern"
87
88                         [ -n "$dev_pattern" -a "cybertan $pattern" != "$dev_pattern" ] && {
89                                 echo "Firmware pattern doesn't match device pattern ($dev_pattern)"
90                                 error=1
91                         }
92
93                         if ! otrx check "$1" -o 32; then
94                                 echo "No valid TRX firmware in the CyberTAN image"
95                                 error=1
96                         fi
97                 ;;
98                 "trx")
99                         if ! otrx check "$1"; then
100                                 echo "Invalid (corrupted?) TRX firmware"
101                                 error=1
102                         fi
103                 ;;
104                 *)
105                         echo "Invalid image type. Please use only .trx files"
106                         error=1
107                 ;;
108         esac
109
110         return $error
111 }
112
113 platform_pre_upgrade() {
114         local file_type=$(platform_identify "$1")
115         local dir="/tmp/sysupgrade-bcm53xx"
116         local trx="$1"
117         local offset
118
119         [ "$(platform_flash_type)" != "nand" ] && return
120
121         # Find trx offset
122         case "$file_type" in
123                 "chk")          offset=$((0x$(get_magic_long_at "$1" 4)));;
124                 "cybertan")     offset=32;;
125         esac
126
127         # Extract partitions from trx
128         rm -fR $dir
129         mkdir -p $dir
130         otrx extract "$trx" \
131                 ${offset:+-o $offset} \
132                 -1 $dir/kernel \
133                 -2 $dir/root
134         [ $? -ne 0 ] && {
135                 echo "Failed to extract TRX partitions."
136                 return
137         }
138
139         # Firmwares without UBI image should be flashed "normally"
140         local root_type=$(identify $dir/root)
141         [ "$root_type" != "ubi" ] && {
142                 echo "Provided firmware doesn't use UBI for rootfs."
143                 return
144         }
145
146         # Prepare TRX file with just a kernel that will replace current one
147         local linux_length=$(grep "\"linux\"" /proc/mtd | sed "s/mtd[0-9]*:[ \t]*\([^ \t]*\).*/\1/")
148         [ -z "$linux_length" ] && {
149                 echo "Unable to find \"linux\" partition size"
150                 exit 1
151         }
152         linux_length=$((0x$linux_length))
153         local kernel_length=$(wc -c $dir/kernel | cut -d ' ' -f 1)
154         [ $kernel_length -gt $linux_length ] && {
155                 echo "New kernel doesn't fit \"linux\" partition."
156                 return
157         }
158         rm -f /tmp/null.bin
159         rm -f /tmp/kernel.trx
160         touch /tmp/null.bin
161         otrx create /tmp/kernel.trx \
162                 -f $dir/kernel -b $(($linux_length + 28)) \
163                 -f /tmp/null.bin
164         [ $? -ne 0 ] && {
165                 echo "Failed to create simple TRX with new kernel."
166                 return
167         }
168
169         # Prepare UBI image (drop unwanted extra blocks)
170         local ubi_length=0
171         while [ "$(dd if=$dir/root skip=$ubi_length bs=1 count=4 2>/dev/null)" = "UBI#" ]; do
172                 ubi_length=$(($ubi_length + 131072))
173         done
174         dd if=$dir/root of=/tmp/root.ubi bs=131072 count=$((ubi_length / 131072)) 2>/dev/null
175         [ $? -ne 0 ] && {
176                 echo "Failed to prepare new UBI image."
177                 return
178         }
179
180         # Flash
181         mtd write /tmp/kernel.trx firmware
182         nand_do_upgrade /tmp/root.ubi
183 }
184
185 platform_trx_from_chk_cmd() {
186         local header_len=$((0x$(get_magic_long_at "$1" 4)))
187
188         echo -n dd bs=$header_len skip=1
189 }
190
191 platform_trx_from_cybertan_cmd() {
192         echo -n dd bs=32 skip=1
193 }
194
195 platform_do_upgrade() {
196         local file_type=$(platform_identify "$1")
197         local trx="$1"
198         local cmd=
199
200         [ "$(platform_flash_type)" == "nand" ] && {
201                 echo "Writing whole image to NAND flash. All erase counters will be lost."
202         }
203
204         case "$file_type" in
205                 "chk")          cmd=$(platform_trx_from_chk_cmd "$trx");;
206                 "cybertan")     cmd=$(platform_trx_from_cybertan_cmd "$trx");;
207         esac
208
209         default_do_upgrade "$trx" "$cmd"
210 }